Attribute VB_Name = "modDialog"
Option Explicit
'----------------------------------------------------------------------------------------------------
'====================================================================================================
'= APIs
'====================================================================================================
'----------------------------------------------------------------------------------------------------
'-----[ File Functions ]-----------------------------------------------------------------------------
'----------------------------------------------------------------------------------------------------
Private Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Private Declare Function CreateFile Lib "kernel32" Alias "CreateFileA" (ByVal lpFileName As String, ByVal dwDesiredAccess As Long, ByVal dwShareMode As Long, ByVal lpSecurityAttributes As Long, ByVal dwCreationDisposition As Long, ByVal dwFlagsAndAttributes As Long, ByVal hTemplateFile As Long) As Long
Private Declare Function ReadFile Lib "kernel32" (ByVal hFile As Long, lpBuffer As ID3V1_TAG, ByVal nNumberOfBytesToRead As Long, lpNumberOfBytesRead As Long, ByVal lpOverlapped As Long) As Long
Private Declare Function SetEndOfFile Lib "kernel32" (ByVal hFile As Long) As Long
Private Declare Function SetFilePointer Lib "kernel32" (ByVal hFile As Long, ByVal lDistanceToMove As Long, ByVal lpDistanceToMoveHigh As Long, ByVal dwMoveMethod As Long) As Long
Private Declare Function WriteFile Lib "kernel32" (ByVal hFile As Long, lpBuffer As ID3V1_TAG, ByVal nNumberOfBytesToWrite As Long, lpNumberOfBytesWritten As Long, ByVal lpOverlapped As Long) As Long
'----------------------------------------------------------------------------------------------------
'-----[ Bitmap Functions ]---------------------------------------------------------------------------
'----------------------------------------------------------------------------------------------------
Private Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Private Declare Function LoadBitmap Lib "user32" Alias "LoadBitmapA" (ByVal hInstance As Long, ByVal lpBitmapName As Long) As Long
'----------------------------------------------------------------------------------------------------
'-----[ Cursor Functions ]---------------------------------------------------------------------------
'----------------------------------------------------------------------------------------------------
Private Declare Function LoadCursor Lib "user32" Alias "LoadCursorA" (ByVal hInstance As Long, ByVal lpCursorName As Long) As Long
Private Declare Function SetCursor Lib "user32" (ByVal hCursor As Long) As Long
'----------------------------------------------------------------------------------------------------
'-----[ Device Context Functions ]-------------------------------------------------------------------
'----------------------------------------------------------------------------------------------------
Private Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hDC As Long) As Long
Private Declare Function DeleteDC Lib "gdi32" (ByVal hDC As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function GetDC Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Function GetObject Lib "gdi32" Alias "GetObjectA" (ByVal hObject As Long, ByVal nCount As Long, lpObject As Any) As Long
Private Declare Function ReleaseDC Lib "user32" (ByVal hWnd As Long, ByVal hDC As Long) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hDC As Long, ByVal hObject As Long) As Long
'----------------------------------------------------------------------------------------------------
'-----[ Dialog Box Functions ]-----------------------------------------------------------------------
'----------------------------------------------------------------------------------------------------
Private Declare Function GetDlgItem Lib "user32" (ByVal hDlg As Long, ByVal nIDDlgItem As Long) As Long
Private Declare Function SendDlgItemMessage Lib "user32" Alias "SendDlgItemMessageA" (ByVal hDlg As Long, ByVal nIDDlgItem As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function SendDlgItemMessageByString Lib "user32" Alias "SendDlgItemMessageA" (ByVal hDlg As Long, ByVal nIDDlgItem As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As String) As Long
'----------------------------------------------------------------------------------------------------
'-----[ Keyboard Input Functions ]-------------------------------------------------------------------
'----------------------------------------------------------------------------------------------------
Private Declare Function EnableWindow Lib "user32" (ByVal hWnd As Long, ByVal fEnable As Long) As Long
'----------------------------------------------------------------------------------------------------
'-----[ Message and Message Queue Functions ]--------------------------------------------------------
'----------------------------------------------------------------------------------------------------
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
'----------------------------------------------------------------------------------------------------
'-----[ Mouse Input Functions ]----------------------------------------------------------------------
'----------------------------------------------------------------------------------------------------
Private Declare Function TrackMouseEvent Lib "user32" (ByRef lpEventTrack As TRACK_MOUSE_EVENT) As Long
'----------------------------------------------------------------------------------------------------
'-----[ Painting and Drawing Functions ]-------------------------------------------------------------
'----------------------------------------------------------------------------------------------------
Private Declare Function BeginPaint Lib "user32" (ByVal hWnd As Long, lpPaint As PAINTSTRUCT) As Long
Private Declare Function EndPaint Lib "user32" (ByVal hWnd As Long, lpPaint As PAINTSTRUCT) As Long
'----------------------------------------------------------------------------------------------------
'-----[ Runtime Library Routines ]-------------------------------------------------------------------
'----------------------------------------------------------------------------------------------------
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, ByVal Source As Long, ByVal Length As Long)
'----------------------------------------------------------------------------------------------------
'-----[ Shell Functions ]----------------------------------------------------------------------------
'----------------------------------------------------------------------------------------------------
Private Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hWnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
'----------------------------------------------------------------------------------------------------
'-----[ Waveform Functions ]-------------------------------------------------------------------------
'----------------------------------------------------------------------------------------------------
Private Declare Function PlaySound Lib "winmm.dll" Alias "PlaySoundA" (ByVal lpszName As Long, ByVal hModule As Long, ByVal dwFlags As Long) As Long
'----------------------------------------------------------------------------------------------------
'-----[ Window Functions ]---------------------------------------------------------------------------
'----------------------------------------------------------------------------------------------------
Private Declare Function GetParent Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Function GetWindowText Lib "user32" Alias "GetWindowTextA" (ByVal hWnd As Long, ByVal lpString As String, ByVal cch As Long) As Long
Private Declare Function GetWindowTextLength Lib "user32" Alias "GetWindowTextLengthA" (ByVal hWnd As Long) As Long
Private Declare Function SetWindowText Lib "user32" Alias "SetWindowTextA" (ByVal hWnd As Long, ByVal lpString As String) As Long
'----------------------------------------------------------------------------------------------------
'-----[ Window Procedure Functions ]-----------------------------------------------------------------
'----------------------------------------------------------------------------------------------------
Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
'----------------------------------------------------------------------------------------------------
'====================================================================================================
'= Const
'====================================================================================================
'---------------------------------------------------------------|------------------------------------
Private Const ID3V1_TAG_ID              As String * 3 = "TAG"   ' ID3v1 Identifier "TAG"
'|
Private Const WM_DESTROY                As Long = &H2           '
Private Const WM_SETTEXT                As Long = &HC           '
Private Const WM_PAINT                  As Long = &HF           '
Private Const WM_SETCURSOR              As Long = &H20          '
Private Const WM_NOTIFY                 As Long = &H4E          '
Private Const WM_HELP                   As Long = &H53          '
Private Const WM_INITDIALOG             As Long = &H110         '
Private Const WM_COMMAND                As Long = &H111         '
Private Const WM_MOUSEMOVE              As Long = &H200         '
Private Const WM_MOUSEHOVER             As Long = &H2A1         '
Private Const WM_MOUSELEAVE             As Long = &H2A3         '
'|
Private Const INVALID_HANDLE_VALUE      As Long = &HFFFFFFFF    '
'|
Private Const GENERIC_WRITE             As Long = &H40000000    ' open for reading
Private Const GENERIC_READ              As Long = &H80000000    ' open for writeing
'|
Private Const FILE_SHARE_READ           As Long = &H1&          ' share reading
'|
Private Const OPEN_EXISTING             As Long = &H3           ' open existing file
'|
Private Const FILE_END                  As Long = &H2           ' seek to file end
'|
Private Const SW_SHOWDEFAULT            As Long = 10            ' show window
'|
Private Const IDC_HAND                  As Long = 32649         ' hand cursor (for links)
'|
Private Const SND_ASYNC                 As Long = &H1           ' play asynchronously
Private Const SND_RESOURCE              As Long = &H40004       ' name is a resource name or atom
'|
Private Const TME_HOVER                 As Long = &H1&          ' capture mouseover
Private Const TME_LEAVE                 As Long = &H2&          ' capture mouseout
'|
Private Const SRCCOPY                   As Long = &HCC0020      ' copy dc
'|
Private Const BST_UNCHECKED             As Long = &H0           ' checkbox unchecked
Private Const BST_CHECKED               As Long = &H1           ' checkbox checked
'|
Private Const BM_GETCHECK               As Long = &HF0          ' get checkbox state
Private Const BM_SETCHECK               As Long = &HF1          ' set checkbox state
'|
Private Const BN_CLICKED                As Long = &H0           ' checkbox was clicked
'|
Private Const STN_CLICKED               As Long = &H0           ' static control was clicked
'|
Private Const EM_LIMITTEXT              As Long = &HC5          ' set the max text length for an edit control
Private Const EM_SETREADONLY            As Long = &HCF          ' set a edit control read only
'|
Private Const EN_UPDATE                 As Long = &H400         ' edit control was changed
'|
Private Const CB_ERRSPACE               As Long = &HFFFFFFFE    ' -2 combobox has not enough memory
Private Const CB_ERR                    As Long = &HFFFFFFFF    ' -1 combobox error
Private Const CB_OKAY                   As Long = &H0           '  0 cobobox success
'|
Private Const CB_ADDSTRING              As Long = &H143         ' add a string to a combobox
Private Const CB_GETCOUNT               As Long = &H146         ' get count of combobox items
Private Const CB_GETCURSEL              As Long = &H147         ' get the selected combobox index
Private Const CB_SETCURSEL              As Long = &H14E         ' set the selected combobox index
Private Const CB_GETITEMDATA            As Long = &H150         ' get the combobox item data
Private Const CB_SETITEMDATA            As Long = &H151         ' set the combobox item data
'|
Private Const CBN_SELCHANGE             As Long = &H1           ' combobox selection was changed
'---------------------------------------------------------------|------------------------------------
'====================================================================================================
'= Enums
'====================================================================================================
'---------------------------------------------------------------|------------------------------------
Private Enum RESOURCE_BITMAPS                                   ' Bitmap ID's from Mp3PropSheetExt.h
    IDB_BANNER_GREY = 101                                       '
    IDB_BANNER_RGB = 102                                        '
End Enum                                                        '
'|
Private Enum RESOURCE_WAVES                                     ' Wave ID's from Mp3PropSheetExt.h
    IDW_MOUSEOVER = 101                                         '
End Enum                                                        '
'|
Private Enum DIALOG_CONTROLS                                    ' Control ID's from Mp3PropSheetExt.h
    IDC_CHECKBOX_ID3V1_TAG = 201                                '
    '                                                           '
    IDC_STATIC_TITLE = 301                                      '
    IDC_STATIC_ARTIST = 302                                     '
    IDC_STATIC_ALBUM = 303                                      '
    IDC_STATIC_YEAR = 304                                       '
    IDC_STATIC_COMMENTS = 305                                   '
    IDC_STATIC_GENRE = 306                                      '
    IDC_STATIC_BANNER = 307                                     '
    '                                                           '
    IDC_STATIC_FIRST = IDC_STATIC_TITLE                         '
    IDC_STATIC_LAST = IDC_STATIC_GENRE                          '
    '                                                           '
    IDC_EDIT_TITLE = 401                                        '
    IDC_EDIT_ARTIST = 402                                       '
    IDC_EDIT_ALBUM = 403                                        '
    IDC_EDIT_YEAR = 404                                         '
    IDC_EDIT_COMMENTS = 405                                     '
    '                                                           '
    IDC_EDIT_FIRST = IDC_EDIT_TITLE                             '
    IDC_EDIT_LAST = IDC_EDIT_COMMENTS                           '
    '                                                           '
    IDC_COMBOBOX_GENRE = 406                                    '
End Enum                                                        '
'|
Private Enum DIALOG_HELP_STRINGS                                ' Help String ID's from Mp3PropSheetExt.h
    IDH_USE_TAG = 501                                           '
    IDH_TITLE = 502                                             '
    IDH_ARTIST = 503                                            '
    IDH_ALBUM = 504                                             '
    IDH_YEAR = 505                                              '
    IDH_COMMENT = 506                                           '
    IDH_GENRE = 507                                             '
    IDH_BANNER = 508                                            '
End Enum                                                        '
'|
Private Enum DIALOG_ERROR_STRINGS                               ' Error String ID's from Mp3PropSheetExt.h
    IDS_ERROR_FILE_READ = 601                                   '
    IDS_ERROR_FILE_WRITE = 602                                  '
End Enum                                                        '
'|
Private Enum DIALOG_GENRE_STRINGS                               ' Genre String ID's from Mp3PropSheetExt.h
    IDS_GENRE_BLUES = 1000                                      '
    IDS_GENRE_CLASSIC_ROCK = 1001                               '
    IDS_GENRE_COUNTRY = 1002                                    '
    IDS_GENRE_DANCE = 1003                                      '
    IDS_GENRE_DISCO = 1004                                      '
    IDS_GENRE_FUNK = 1005                                       '
    IDS_GENRE_GRUNGE = 1006                                     '
    IDS_GENRE_HIP_HOP = 1007                                    '
    IDS_GENRE_JAZZ = 1008                                       '
    IDS_GENRE_METAL = 1009                                      '
    IDS_GENRE_NEW_AGE = 1010                                    '
    IDS_GENRE_OLDIES = 1011                                     '
    IDS_GENRE_OTHER = 1012                                      '
    IDS_GENRE_POP = 1013                                        '
    IDS_GENRE_R_B = 1014                                        '
    IDS_GENRE_RAP = 1015                                        '
    IDS_GENRE_REGGAE = 1016                                     '
    IDS_GENRE_ROCK = 1017                                       '
    IDS_GENRE_TECHNO = 1018                                     '
    IDS_GENRE_INDUSTRIAL = 1019                                 '
    IDS_GENRE_ALTERNATIVE = 1020                                '
    IDS_GENRE_SKA = 1021                                        '
    IDS_GENRE_DEATH_METAL = 1022                                '
    IDS_GENRE_PRANKS = 1023                                     '
    IDS_GENRE_SOUNDTRACK = 1024                                 '
    IDS_GENRE_EURO_TECHNO = 1025                                '
    IDS_GENRE_AMBIENT = 1026                                    '
    IDS_GENRE_TRIP_HOP = 1027                                   '
    IDS_GENRE_VOCAL = 1028                                      '
    IDS_GENRE_JAZZ_FUNK = 1029                                  '
    IDS_GENRE_FUSION = 1030                                     '
    IDS_GENRE_TRANCE = 1031                                     '
    IDS_GENRE_CLASSICAL = 1032                                  '
    IDS_GENRE_INSTRUMENTAL = 1033                               '
    IDS_GENRE_ACID = 1034                                       '
    IDS_GENRE_HOUSE = 1035                                      '
    IDS_GENRE_GAME = 1036                                       '
    IDS_GENRE_SOUND_CLIP = 1037                                 '
    IDS_GENRE_GOSPEL = 1038                                     '
    IDS_GENRE_NOISE = 1039                                      '
    IDS_GENRE_ALTERNROCK = 1040                                 '
    IDS_GENRE_BASS = 1041                                       '
    IDS_GENRE_SOUL = 1042                                       '
    IDS_GENRE_PUNK = 1043                                       '
    IDS_GENRE_SPACE = 1044                                      '
    IDS_GENRE_MEDITATIVE = 1045                                 '
    IDS_GENRE_INSTRUMENTAL_POP = 1046                           '
    IDS_GENRE_INSTRUMENTAL_ROCK = 1047                          '
    IDS_GENRE_ETHNIC = 1048                                     '
    IDS_GENRE_GOTHIC = 1049                                     '
    IDS_GENRE_DARKWAVE = 1050                                   '
    IDS_GENRE_TECHNO_INDUSTRIAL = 1051                          '
    IDS_GENRE_ELECTRONIC = 1052                                 '
    IDS_GENRE_POP_FOLK = 1053                                   '
    IDS_GENRE_EURODANCE = 1054                                  '
    IDS_GENRE_DREAM = 1055                                      '
    IDS_GENRE_SOUTHERN_ROCK = 1056                              '
    IDS_GENRE_COMEDY = 1057                                     '
    IDS_GENRE_CULT = 1058                                       '
    IDS_GENRE_GANGSTA = 1059                                    '
    IDS_GENRE_TOP_40 = 1060                                     '
    IDS_GENRE_CHRISTIAN_RAP = 1061                              '
    IDS_GENRE_POP_FUNK = 1062                                   '
    IDS_GENRE_JUNGLE = 1063                                     '
    IDS_GENRE_NATIVE_AMERICAN = 1064                            '
    IDS_GENRE_CABARET = 1065                                    '
    IDS_GENRE_NEW_WAVE = 1066                                   '
    IDS_GENRE_PSYCHADELIC = 1067                                '
    IDS_GENRE_RAVE = 1068                                       '
    IDS_GENRE_SHOWTUNES = 1069                                  '
    IDS_GENRE_TRAILER = 1070                                    '
    IDS_GENRE_LO_FI = 1071                                      '
    IDS_GENRE_TRIBAL = 1072                                     '
    IDS_GENRE_ACID_PUNK = 1073                                  '
    IDS_GENRE_ACID_JAZZ = 1074                                  '
    IDS_GENRE_POLKA = 1075                                      '
    IDS_GENRE_RETRO = 1076                                      '
    IDS_GENRE_MUSICAL = 1077                                    '
    IDS_GENRE_ROCK_AND_ROLL = 1078                              '
    IDS_GENRE_HARD_ROCK = 1079                                  '
    IDS_GENRE_FOLK = 1080                                       '
    IDS_GENRE_FOLK_ROCK = 1081                                  '
    IDS_GENRE_NATIONAL_FOLK = 1082                              '
    IDS_GENRE_SWING = 1083                                      '
    IDS_GENRE_FAST_FUSION = 1084                                '
    IDS_GENRE_BEBOB = 1085                                      '
    IDS_GENRE_LATIN = 1086                                      '
    IDS_GENRE_REVIVAL = 1087                                    '
    IDS_GENRE_CELTIC = 1088                                     '
    IDS_GENRE_BLUEGRASS = 1089                                  '
    IDS_GENRE_AVANTGARDE = 1090                                 '
    IDS_GENRE_GOTHIC_ROCK = 1091                                '
    IDS_GENRE_PROGRESSIVE_ROCK = 1092                           '
    IDS_GENRE_PSYCHEDELIC_ROCK = 1093                           '
    IDS_GENRE_SYMPHONIC_ROCK = 1094                             '
    IDS_GENRE_SLOW_ROCK = 1095                                  '
    IDS_GENRE_BIG_BAND = 1096                                   '
    IDS_GENRE_CHORUS = 1097                                     '
    IDS_GENRE_EASY_LISTENING = 1098                             '
    IDS_GENRE_ACOUSTIC = 1099                                   '
    IDS_GENRE_HUMOUR = 1100                                     '
    IDS_GENRE_SPEECH = 1101                                     '
    IDS_GENRE_CHANSON = 1102                                    '
    IDS_GENRE_OPERA = 1103                                      '
    IDS_GENRE_CHAMBER_MUSIC = 1104                              '
    IDS_GENRE_SONATA = 1105                                     '
    IDS_GENRE_SYMPHONY = 1106                                   '
    IDS_GENRE_BOOTY_BASS = 1107                                 '
    IDS_GENRE_PRIMUS = 1108                                     '
    IDS_GENRE_PORN_GROOVE = 1109                                '
    IDS_GENRE_SATIRE = 1110                                     '
    IDS_GENRE_SLOW_JAM = 1111                                   '
    IDS_GENRE_CLUB = 1112                                       '
    IDS_GENRE_TANGO = 1113                                      '
    IDS_GENRE_SAMBA = 1114                                      '
    IDS_GENRE_FOLKLORE = 1115                                   '
    IDS_GENRE_BALLAD = 1116                                     '
    IDS_GENRE_POWER_BALLAD = 1117                               '
    IDS_GENRE_RHYTHMIC_SOUL = 1118                              '
    IDS_GENRE_FREESTYLE = 1119                                  '
    IDS_GENRE_DUET = 1120                                       '
    IDS_GENRE_PUNK_ROCK = 1121                                  '
    IDS_GENRE_DRUM_SOLO = 1122                                  '
    IDS_GENRE_A_CAPELLA = 1123                                  '
    IDS_GENRE_EURO_HOUSE = 1124                                 '
    IDS_GENRE_DANCE_HALL = 1125                                 '
    '                                                           '
    IDS_GENRE_FIRST = IDS_GENRE_BLUES                           '
    IDS_GENRE_LAST = IDS_GENRE_DANCE_HALL                       '
End Enum                                                        '
'---------------------------------------------------------------|------------------------------------
'====================================================================================================
'= Types
'====================================================================================================
'---------------------------------------------------------------|------------------------------------
Private Type BITMAP                                             '
    bmType                              As Long                 '
    bmWidth                             As Long                 '
    bmHeight                            As Long                 '
    bmWidthBytes                        As Long                 '
    bmPlanes                            As Integer              '
    bmBitsPixel                         As Integer              '
    bmBits                              As Long                 '
End Type                                                        '
'|
Private Type ID3V1_TAG                                          '
    ID                                  As String * 3           ' ID3v1 Identifier "TAG"
    Title                               As String * 30          ' Title
    Artist                              As String * 30          ' Artist
    Album                               As String * 30          ' Album
    Year                                As String * 4           ' Year
    Comment                             As String * 30          ' Comment
    Genre                               As Byte                 ' Genre ID
End Type                                                        '
'|
Private Type PAINTSTRUCT                                        '
    hDC                                 As Long                 '
    fErase                              As Long                 '
    rcPaint                             As RECT                 '
    fRestore                            As Long                 '
    fIncUpdate                          As Long                 '
    rgbReserved(32)                     As Byte                 '
End Type                                                        '
'|
Private Type TRACK_MOUSE_EVENT                                  '
    cbSize                              As Long                 '
    dwFlags                             As Long                 '
    hwndTrack                           As Long                 '
    dwHoverTime                         As Long                 '
End Type                                                        '
'---------------------------------------------------------------|------------------------------------
'====================================================================================================
'= Vars
'====================================================================================================
'---------------------------------------------------------------|------------------------------------
Private dwHtmlHelpCookie                As Long                 ' needed for HH_INITIALIZE ad HH_UNINITIALIZE
Private wpBannerWndProc                 As Long                 '
Private blnBannerMouseover              As Boolean              '
'---------------------------------------------------------------|------------------------------------
'----------------------------------------------------------------------------------------------------



'####################################################################################################
'#####[ DlgProc ]####################################################################################
'####################################################################################################
Public Function DlgProc(ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    On Error Resume Next
    '
    Select Case uMsg
        Case WM_INITDIALOG: DlgProc = OnInitDialog(hWnd, wParam, lParam)
        Case WM_COMMAND:    DlgProc = OnCommand(hWnd, HiWord(wParam), LoWord(wParam), lParam)
        Case WM_NOTIFY:     DlgProc = OnNotify(hWnd, wParam, lParam)
        Case WM_HELP:       DlgProc = OnHelp(hWnd, lParam)
        Case WM_DESTROY:    DlgProc = OnDestroy(hWnd)
        Case Else:          DlgProc = 0
    End Select
End Function

'####################################################################################################
'#####[ OnInitDialog ]###############################################################################
'####################################################################################################
Private Function OnInitDialog(hDialog As Long, hwndFocus As Long, lInitParam As Long) As Long
    Dim udtID3v1Tag As ID3V1_TAG
    Dim hBanner     As Long
    Dim hFile       As Long
    Dim nIndex      As Long
    Dim nGenreID    As Long
    Dim i           As Long
    Dim blnError    As Boolean
    '
    ' HH_INITIALIZE configures HTML Help to run on the same thread as the calling application
    ' you MUST call HtmlHelp() with HH_INITIALIZE (and HH_UNINITIALIZE in OnDestroy) if you
    ' use HtmlHelp() to display help popups! if you dont call it, the windows explorer /can/ crash!
    Call HtmlHelp(0, vbNullString, HH_INITIALIZE, dwHtmlHelpCookie)
    '
    ' subclass the banner
    '
    hBanner = GetDlgItem(hDialog, IDC_STATIC_BANNER)
    If hBanner <> 0 Then
        wpBannerWndProc = SetWindowLong(hBanner, GWL_WNDPROC, AddressOf BannerWndProc)
    End If
    '
    ' load the labels
    '
    Control_SetText hDialog, IDC_CHECKBOX_ID3V1_TAG, LoadResString(IDC_CHECKBOX_ID3V1_TAG)
    For i = IDC_STATIC_FIRST To IDC_STATIC_LAST
        Control_SetText hDialog, i, LoadResString(i)
    Next i
    '
    ' set max length for edit controls
    '
    Edit_LimitText hDialog, IDC_EDIT_TITLE, Len(udtID3v1Tag.Title)
    Edit_LimitText hDialog, IDC_EDIT_ARTIST, Len(udtID3v1Tag.Artist)
    Edit_LimitText hDialog, IDC_EDIT_ALBUM, Len(udtID3v1Tag.Album)
    Edit_LimitText hDialog, IDC_EDIT_YEAR, Len(udtID3v1Tag.Year)
    Edit_LimitText hDialog, IDC_EDIT_COMMENTS, Len(udtID3v1Tag.Comment)
    '
    ' read the ID3v1 tag
    '
    hFile = File_Open(modPropSheet.m_FilePath(1), GENERIC_READ, FILE_SHARE_READ, OPEN_EXISTING)
    If hFile <> INVALID_HANDLE_VALUE Then
        udtID3v1Tag = File_GetID3v1Tag(hFile)
        Call File_Close(hFile)
    Else
        blnError = True
    End If
    '
    ' fill the combobox
    '
    nIndex = Combobox_AddItem(hDialog, IDC_COMBOBOX_GENRE, "")
    If nIndex >= CB_OKAY Then
        nGenreID = &HFF
        Combobox_SetItemData hDialog, IDC_COMBOBOX_GENRE, nIndex, nGenreID
    End If
    '
    For i = IDS_GENRE_FIRST To IDS_GENRE_LAST
        nIndex = Combobox_AddItem(hDialog, IDC_COMBOBOX_GENRE, LoadResString(i))
        If nIndex >= CB_OKAY Then
            nGenreID = (i - 1000)
            Combobox_SetItemData hDialog, IDC_COMBOBOX_GENRE, nIndex, nGenreID
        End If
    Next i
    '
    ' show the ID3v1 tag
    '
    If UCase$(udtID3v1Tag.ID) = ID3V1_TAG_ID Then
        Checkbox_SetCheckState hDialog, IDC_CHECKBOX_ID3V1_TAG, True
        '
        Control_SetText hDialog, IDC_EDIT_TITLE, Trim$(StripNull(udtID3v1Tag.Title))
        Control_SetText hDialog, IDC_EDIT_ARTIST, Trim$(StripNull(udtID3v1Tag.Artist))
        Control_SetText hDialog, IDC_EDIT_ALBUM, Trim$(StripNull(udtID3v1Tag.Album))
        Control_SetText hDialog, IDC_EDIT_YEAR, Trim$(StripNull(udtID3v1Tag.Year))
        Control_SetText hDialog, IDC_EDIT_COMMENTS, Trim$(StripNull(udtID3v1Tag.Comment))
        '
        nIndex = Combobox_GetIndexByItemData(hDialog, IDC_COMBOBOX_GENRE, CLng(udtID3v1Tag.Genre))
        If nIndex <> CB_ERR Then
            Combobox_SetSelectedIndex hDialog, IDC_COMBOBOX_GENRE, nIndex
        End If
        '
        Dialog_SetControlsDisabled hDialog, False
    End If
    '
    ' show a message box if a read error occured
    '
    If blnError = True Then
        MsgBox LoadResString(IDS_ERROR_FILE_READ), vbOKOnly Or vbExclamation
    End If
    '
    OnInitDialog = 0
End Function

'####################################################################################################
'#####[ OnCommand ]##################################################################################
'####################################################################################################
Private Function OnCommand(hDialog As Long, wNotifyCode As Long, wID As Long, hwndCtl As Long) As Long
    Dim nIndex      As Long
    Dim nGenreID    As Long
    Dim blnDisabled As Boolean
    '
    Select Case wID
        Case IDC_CHECKBOX_ID3V1_TAG
            Select Case wNotifyCode
                Case BN_CLICKED
                    blnDisabled = Not Checkbox_GetCheckState(hDialog, IDC_CHECKBOX_ID3V1_TAG)
                    Dialog_SetControlsDisabled hDialog, blnDisabled
                    PropertySheet_Changed GetParent(hDialog), hDialog
            End Select
        Case IDC_EDIT_FIRST To IDC_EDIT_LAST
            Select Case wNotifyCode
                Case EN_UPDATE
                    PropertySheet_Changed GetParent(hDialog), hDialog
            End Select
        Case IDC_COMBOBOX_GENRE
            Select Case wNotifyCode
                Case CBN_SELCHANGE
                    nIndex = Combobox_GetSelectedIndex(hDialog, IDC_COMBOBOX_GENRE)
                    If nIndex <> CB_ERR Then
                        nGenreID = Combobox_GetItemData(hDialog, IDC_COMBOBOX_GENRE, nIndex)
                    End If
                    PropertySheet_Changed GetParent(hDialog), hDialog
            End Select
        Case IDC_STATIC_BANNER
            Select Case wNotifyCode
                Case STN_CLICKED
                    Call ShellExecute(hDialog, "open", "http://foren.activevb.de/cgi-bin/foren/list.pl?forum=4", "", "", SW_SHOWDEFAULT)
            End Select
    End Select
    '
    OnCommand = 0
End Function

'####################################################################################################
'#####[ OnNotify ]###################################################################################
'####################################################################################################
Private Function OnNotify(hDialog As Long, idCtrl As Long, lppsn As Long) As Long
    Dim udtPShNotify As PSHNOTIFY
    Dim udtID3v1Tag  As ID3V1_TAG
    Dim hFile        As Long
    Dim nIndex       As Long
    Dim nGenre       As Long
    Dim lResult      As Long
    Dim blnSuccess   As Boolean
    '
    Call CopyMemory(udtPShNotify, lppsn, Len(udtPShNotify))
    '
    Select Case udtPShNotify.hdr.code
        Case PSN_APPLY
            hFile = File_Open(modPropSheet.m_FilePath(1), GENERIC_READ Or GENERIC_WRITE, FILE_SHARE_READ, OPEN_EXISTING)
            If hFile <> INVALID_HANDLE_VALUE Then
                If Checkbox_GetCheckState(hDialog, IDC_CHECKBOX_ID3V1_TAG) = True Then
                    With udtID3v1Tag
                        .ID = ID3V1_TAG_ID
                        .Title = Control_GetText(hDialog, IDC_EDIT_TITLE) & String$(Len(.Title), vbNullChar)
                        .Artist = Control_GetText(hDialog, IDC_EDIT_ARTIST) & String$(Len(.Artist), vbNullChar)
                        .Album = Control_GetText(hDialog, IDC_EDIT_ALBUM) & String$(Len(.Album), vbNullChar)
                        .Year = Control_GetText(hDialog, IDC_EDIT_YEAR) & String$(Len(.Year), vbNullChar)
                        .Comment = Control_GetText(hDialog, IDC_EDIT_COMMENTS) & String$(Len(.Comment), vbNullChar)
                        '
                        nIndex = Combobox_GetSelectedIndex(hDialog, IDC_COMBOBOX_GENRE)
                        If nIndex <> CB_ERR Then
                            nGenre = Combobox_GetItemData(hDialog, IDC_COMBOBOX_GENRE, nIndex)
                        Else
                            nGenre = CB_ERR
                        End If
                        '
                        If nGenre <> CB_ERR Then
                            .Genre = CByte(nGenre)
                        Else
                            .Genre = &HFF
                        End If
                    End With
                    blnSuccess = File_SetID3v1Tag(hFile, udtID3v1Tag)
                Else
                    blnSuccess = File_DelID3v1Tag(hFile)
                End If
                Call File_Close(hFile)
            End If
            '
            If blnSuccess = True Then
                lResult = PSNRET_NOERROR
            Else
                MsgBox LoadResString(IDS_ERROR_FILE_WRITE), vbOKOnly Or vbExclamation
                '
                lResult = PSNRET_INVALID_NOCHANGEPAGE
            End If
        Case Else
            lResult = 0
    End Select
    '
    Call SetWindowLong(hDialog, DWL_MSGRESULT, lResult)
    '
    OnNotify = lResult
End Function

'####################################################################################################
'#####[ OnHelp ]#####################################################################################
'####################################################################################################
Private Function OnHelp(hDialog As Long, lphi As Long) As Long
    Dim udtHelpInfo As HELPINFO
    Dim udtHHPopup  As HH_POPUP
    Dim lStringID   As Long
    Dim lResult     As Long
    '
    Call CopyMemory(udtHelpInfo, lphi, Len(udtHelpInfo))
    '
    Select Case udtHelpInfo.iCtrlId
        Case IDC_CHECKBOX_ID3V1_TAG:                    lStringID = IDH_USE_TAG
        Case IDC_STATIC_TITLE, IDC_EDIT_TITLE:          lStringID = IDH_TITLE
        Case IDC_STATIC_ARTIST, IDC_EDIT_ARTIST:        lStringID = IDH_ARTIST
        Case IDC_STATIC_ALBUM, IDC_EDIT_ALBUM:          lStringID = IDH_ALBUM
        Case IDC_STATIC_YEAR, IDC_EDIT_YEAR:            lStringID = IDH_YEAR
        Case IDC_STATIC_GENRE, IDC_COMBOBOX_GENRE:      lStringID = IDH_GENRE
        Case IDC_STATIC_COMMENTS, IDC_EDIT_COMMENTS:    lStringID = IDH_COMMENT
        Case IDC_STATIC_BANNER:                         lStringID = IDH_BANNER
        Case Else:                                      lStringID = 0
    End Select
    '
    With udtHHPopup
        .cbStruct = Len(udtHHPopup)
        .hinst = App.hInstance
        .idString = lStringID
        .pszText = vbNullString
        .pt.x = udtHelpInfo.MousePos.x
        .pt.y = udtHelpInfo.MousePos.y
        .clrForeground = -1
        .clrBackground = -1
        .rcMargins.Left = -1
        .rcMargins.Top = -1
        .rcMargins.Right = -1
        .rcMargins.Bottom = -1
        .pszFont = vbNullString
    End With
    '
    lResult = HtmlHelp(udtHelpInfo.hItemHandle, vbNullString, HH_DISPLAY_TEXT_POPUP, udtHHPopup)
    '
    OnHelp = 1
End Function

'####################################################################################################
'#####[ OnDestroy ]##################################################################################
'####################################################################################################
Private Function OnDestroy(hDialog As Long) As Long
    Dim hBanner As Long
    '
    ' UnSubclass
    '
    hBanner = GetDlgItem(hDialog, IDC_STATIC_BANNER)
    If hBanner <> 0 Then
        Call SetWindowLong(hBanner, GWL_WNDPROC, wpBannerWndProc)
    End If
    '
    ' This command is called to properly shut down HTML Help.
    ' you MUST call HtmlHelp() with HH_UNINITIALIZE (and HH_INITIALIZE in OnInitDialog) if you
    ' use HtmlHelp() to display help popups! if you dont call it the windows explorer /can/ crash
    Call HtmlHelp(0, vbNullString, HH_UNINITIALIZE, dwHtmlHelpCookie)
    '
    OnDestroy = 0
End Function

'####################################################################################################
'#####[ BannerWndProc ]##############################################################################
'####################################################################################################
Public Function BannerWndProc(ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    Dim tme       As TRACK_MOUSE_EVENT
    Dim ps        As PAINTSTRUCT
    Dim hCursor   As Long
    Dim hDC       As Long
    '
    On Error Resume Next
    '
    Select Case uMsg
        Case WM_SETCURSOR
            hCursor = LoadCursor(0, IDC_HAND)
            If hCursor <> 0 Then
                Call SetCursor(hCursor)
            End If
            '
            BannerWndProc = 1
            Exit Function
        Case WM_MOUSEHOVER
            If blnBannerMouseover = False Then
                blnBannerMouseover = True
                '
                hDC = GetDC(hWnd)
                Call DrawBanner(hDC, IDB_BANNER_RGB)
                Call ReleaseDC(hWnd, hDC)
                Call PlaySound(IDW_MOUSEOVER, App.hInstance, SND_ASYNC Or SND_RESOURCE)
            End If
        Case WM_MOUSELEAVE
            If blnBannerMouseover = True Then
                blnBannerMouseover = False
                '
                hDC = GetDC(hWnd)
                Call DrawBanner(hDC, IDB_BANNER_GREY)
                Call ReleaseDC(hWnd, hDC)
                Call PlaySound(IDW_MOUSEOVER, App.hInstance, SND_ASYNC Or SND_RESOURCE)
            End If
        Case WM_PAINT
            hDC = BeginPaint(hWnd, ps)
            '
            If blnBannerMouseover = True Then
                Call DrawBanner(hDC, IDB_BANNER_RGB)
            Else
                Call DrawBanner(hDC, IDB_BANNER_GREY)
            End If
            '
            Call EndPaint(hWnd, ps)
        Case WM_MOUSEMOVE
            tme.cbSize = Len(tme)
            tme.dwFlags = TME_HOVER Or TME_LEAVE
            tme.hwndTrack = hWnd
            tme.dwHoverTime = 1
            '
            Call TrackMouseEvent(tme)
    End Select
    '
    BannerWndProc = CallWindowProc(wpBannerWndProc, hWnd, uMsg, wParam, lParam)
End Function

Private Function DrawBanner(hDC As Long, idBitmap As Long) As Boolean
    Dim bm      As BITMAP
    Dim hBitmap As Long
    Dim hOldBmp As Long
    Dim hMemDC  As Long
    Dim lResult As Long
    Dim bReturn As Boolean
    '
    hBitmap = LoadBitmap(App.hInstance, idBitmap)
    If hBitmap <> 0 Then
        lResult = GetObject(hBitmap, Len(bm), bm)
        If lResult <> 0 Then
            hMemDC = CreateCompatibleDC(hDC)
            If hMemDC <> 0 Then
                hOldBmp = SelectObject(hMemDC, hBitmap)
                If hOldBmp <> 0 Then
                    lResult = BitBlt(hDC, 0, 0, bm.bmWidth, bm.bmHeight, hMemDC, 0, 0, SRCCOPY)  '306, 126
                    If lResult <> 0 Then
                        bReturn = True
                    End If
                    lResult = SelectObject(hMemDC, hOldBmp)
                End If
                Call DeleteDC(hMemDC)
            End If
            Call DeleteObject(hBitmap)
        End If
    End If
    '
    DrawBanner = bReturn
End Function

'####################################################################################################
'#####[ Property Sheet ]#############################################################################
'####################################################################################################
Private Sub PropertySheet_Changed(hPage As Long, hDialog As Long)
    Call SendMessage(hPage, PSM_CHANGED, hDialog, 0&)
End Sub

'####################################################################################################
'#####[ Dialog ]#####################################################################################
'####################################################################################################
Private Sub Dialog_SetControlsDisabled(hDialog As Long, blnDisabled As Boolean)
    Edit_SetReadOnly hDialog, IDC_EDIT_TITLE, blnDisabled
    Edit_SetReadOnly hDialog, IDC_EDIT_ARTIST, blnDisabled
    Edit_SetReadOnly hDialog, IDC_EDIT_ALBUM, blnDisabled
    Edit_SetReadOnly hDialog, IDC_EDIT_YEAR, blnDisabled
    Edit_SetReadOnly hDialog, IDC_EDIT_COMMENTS, blnDisabled
    '
    Control_SetDisabled hDialog, IDC_COMBOBOX_GENRE, blnDisabled
End Sub

'####################################################################################################
'#####[ Checkbox ]###################################################################################
'####################################################################################################
Private Function Checkbox_GetCheckState(hDialog As Long, nControlID As Long) As Boolean
    Dim lResult As Long
    '
    lResult = SendDlgItemMessage(hDialog, nControlID, BM_GETCHECK, 0&, 0&)
    '
    Checkbox_GetCheckState = (lResult = BST_CHECKED)
End Function

Private Sub Checkbox_SetCheckState(hDialog As Long, nControlID As Long, blnChecked As Boolean)
    Call SendDlgItemMessage(hDialog, nControlID, BM_SETCHECK, IIf(blnChecked, BST_CHECKED, BST_UNCHECKED), 0&)
End Sub

'####################################################################################################
'#####[ Combobox ]###################################################################################
'####################################################################################################
Private Function Combobox_AddItem(hDialog As Long, nControlID As Long, strItem As String) As Long
    Dim lResult As Long
    '
    lResult = SendDlgItemMessageByString(hDialog, nControlID, CB_ADDSTRING, 0&, strItem)
    '
    Combobox_AddItem = lResult
End Function

Private Function Combobox_GetCount(hDialog As Long, nControlID As Long) As Long
    Dim lResult As Long
    '
    lResult = SendDlgItemMessage(hDialog, nControlID, CB_GETCOUNT, 0&, 0&)
    '
    Combobox_GetCount = lResult
End Function

Private Function Combobox_GetIndexByItemData(hDialog As Long, nControlID As Long, lngItemData As Long) As Long
    Dim lResult As Long
    Dim lCount  As Long
    Dim i       As Long
    '
    lResult = CB_ERR
    '
    lCount = Combobox_GetCount(hDialog, nControlID)
    '
    For i = 0 To lCount - 1
        If lngItemData = Combobox_GetItemData(hDialog, nControlID, i) Then
            lResult = i
            Exit For
        End If
    Next i
    '
    Combobox_GetIndexByItemData = lResult
End Function

Private Function Combobox_GetItemData(hDialog As Long, nControlID As Long, nIndex As Long) As Long
    Dim lResult As Long
    '
    lResult = SendDlgItemMessage(hDialog, nControlID, CB_GETITEMDATA, nIndex, 0&)
    '
    Combobox_GetItemData = lResult
End Function

Private Function Combobox_GetSelectedIndex(hDialog As Long, nControlID As Long) As Long
    Dim lResult As Long
    '
    lResult = SendDlgItemMessage(hDialog, nControlID, CB_GETCURSEL, 0&, 0&)
    '
    Combobox_GetSelectedIndex = lResult
End Function

Private Function Combobox_SetItemData(hDialog As Long, nControlID As Long, nIndex As Long, lngItemData As Long) As Boolean
    Dim lResult As Long
    '
    lResult = SendDlgItemMessage(hDialog, nControlID, CB_SETITEMDATA, nIndex, lngItemData)
    '
    Combobox_SetItemData = (lResult <> CB_ERR)
End Function

Private Function Combobox_SetSelectedIndex(hDialog As Long, nControlID As Long, lngIndex As Long) As Boolean
    Dim lResult As Long
    '
    lResult = SendDlgItemMessage(hDialog, nControlID, CB_SETCURSEL, lngIndex, 0&)
    '
    Combobox_SetSelectedIndex = (lResult <> CB_ERR)
End Function

'####################################################################################################
'#####[ Edit ]#######################################################################################
'####################################################################################################
Private Sub Edit_LimitText(hDialog As Long, nControlID As Long, lngLength As Long)
    Call SendDlgItemMessage(hDialog, nControlID, EM_LIMITTEXT, lngLength, 0&)
End Sub

Private Function Edit_SetReadOnly(hDialog As Long, nControlID As Long, blnReadOnly As Boolean) As Boolean
    Dim lResult As Long
    '
    If blnReadOnly = True Then
        lResult = SendDlgItemMessage(hDialog, nControlID, EM_SETREADONLY, 1&, 0&)
    Else
        lResult = SendDlgItemMessage(hDialog, nControlID, EM_SETREADONLY, 0&, 0&)
    End If
    '
    Edit_SetReadOnly = (lResult <> 0)
End Function

'####################################################################################################
'#####[ Control ]####################################################################################
'####################################################################################################
Private Function Control_SetDisabled(hDialog As Long, nControlID As Long, blnDisabled As Boolean) As Boolean
    Dim hControl As Long
    Dim lStyle   As Long
    Dim lResult  As Long
    '
    hControl = GetDlgItem(hDialog, nControlID)
    '
    If hControl <> 0 Then
        lResult = EnableWindow(hControl, IIf(blnDisabled, 0, 1))
    End If
    '
    Control_SetDisabled = (lResult <> 0)
End Function

Private Function Control_GetText(hDialog As Long, nControlID As Long) As String
    Dim sBuffer  As String
    Dim lBuffer  As Long
    Dim lResult  As Long
    Dim hControl As Long
    '
    hControl = GetDlgItem(hDialog, nControlID)
    If hControl <> 0 Then
        lBuffer = GetWindowTextLength(hControl)
        If lBuffer > 0 Then
            sBuffer = String$(lBuffer + 1, vbNullChar)
            lResult = GetWindowText(hControl, sBuffer, lBuffer + 1)
            If lResult > 0 Then
                Control_GetText = Left$(sBuffer, lResult)
            End If
        End If
    End If
End Function

Private Function Control_SetText(hDialog As Long, nControlID As Long, strText As String) As Boolean
    Dim lResult  As Long
    Dim hControl As Long
    '
    hControl = GetDlgItem(hDialog, nControlID)
    If hControl <> 0 Then
        lResult = SetWindowText(hControl, strText)
        If lResult <> 0 Then
            Control_SetText = True
        End If
    End If
End Function

'####################################################################################################
'#####[ ID3v1 Tag ]##################################################################################
'####################################################################################################
Private Function File_Open(strFilePath As String, lngAccessType As Long, lngShareMode As Long, lngOpenType As Long) As Long
    Dim hFile As Long
    '
    hFile = CreateFile( _
        strFilePath, _
        lngAccessType, _
        lngShareMode, _
        0&, _
        lngOpenType, _
        0&, _
        0& _
        )
    '
    File_Open = hFile
End Function

Private Function File_GetID3v1Tag(ByVal hFile As Long) As ID3V1_TAG
    Dim udtID3v1Tag As ID3V1_TAG
    Dim lBytesRead  As Long
    Dim lLength     As Long
    Dim lResult     As Long
    '
    lLength = Len(udtID3v1Tag)
    '
    lResult = SetFilePointer(hFile, -lLength, 0&, FILE_END)
    '
    If lResult <> INVALID_HANDLE_VALUE Then
        lResult = ReadFile(hFile, udtID3v1Tag, lLength, lBytesRead, 0&)
        If lResult <> 0 Then
            If lBytesRead = lLength Then
                File_GetID3v1Tag = udtID3v1Tag
            End If
        End If
    End If
End Function

Private Function File_SetID3v1Tag(ByVal hFile As Long, ByRef udtID3v1Tag As ID3V1_TAG) As Boolean
    Dim udtID3v1TagOld As ID3V1_TAG
    Dim lBytesWritten  As Long
    Dim lLength        As Long
    Dim lResult        As Long
    Dim bResult        As Boolean
    '
    udtID3v1TagOld = File_GetID3v1Tag(hFile)
    '
    lLength = Len(udtID3v1Tag)
    '
    If UCase$(udtID3v1TagOld.ID) = ID3V1_TAG_ID Then
        lResult = SetFilePointer(hFile, -lLength, 0&, FILE_END)
        If lResult <> INVALID_HANDLE_VALUE Then
            lResult = WriteFile(hFile, udtID3v1Tag, lLength, lBytesWritten, 0&)
            If lResult <> 0 Then
                bResult = (lBytesWritten = lLength)
            End If
        End If
    Else
        lResult = SetFilePointer(hFile, 0&, 0&, FILE_END)
        If lResult <> INVALID_HANDLE_VALUE Then
            lResult = WriteFile(hFile, udtID3v1Tag, lLength, lBytesWritten, 0&)
            If lResult <> 0 Then
                bResult = (lBytesWritten = lLength)
            End If
        End If
    End If
    '
    File_SetID3v1Tag = bResult
End Function

Private Function File_DelID3v1Tag(ByVal hFile As Long) As Boolean
    Dim udtID3v1Tag As ID3V1_TAG
    Dim lLength     As Long
    Dim lResult     As Long
    Dim bResult     As Boolean
    '
    udtID3v1Tag = File_GetID3v1Tag(hFile)
    '
    If UCase$(udtID3v1Tag.ID) = ID3V1_TAG_ID Then
        lLength = Len(udtID3v1Tag)
        lResult = SetFilePointer(hFile, -lLength, 0&, FILE_END)
        If lResult <> INVALID_HANDLE_VALUE Then
            lResult = SetEndOfFile(hFile)
            If lResult <> 0 Then
                bResult = True
            End If
        End If
    Else
        bResult = True
    End If
    '
    File_DelID3v1Tag = bResult
End Function

Private Function File_Close(ByVal hFile As Long) As Boolean
    Dim lResult As Long
    '
    lResult = CloseHandle(hFile)
    '
    File_Close = (lResult <> 0)
End Function

'####################################################################################################
'#####[ Helper ]#####################################################################################
'####################################################################################################
Private Function HiWord(ByVal Value As Long) As Integer
    HiWord = (Value And &HFFFF0000) \ &HFFFF&
End Function

Private Function LoWord(ByVal Value As Long) As Integer
    If Value And &H8000& Then
        LoWord = Value Or &HFFFF0000
    Else
        LoWord = Value And &HFFFF&
    End If
End Function

Public Function StripNull(strData As String) As String
    Dim lngPos As Long
    '
    lngPos = InStr(strData, vbNullChar)
    '
    If lngPos > 0 Then
        StripNull = Left$(strData, (lngPos - 1))
    Else
        StripNull = strData
    End If
End Function
